#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>

#define BLACK 0x0000
#define GREEN 0x07E0
#define RED 0xF800
#define WHITE 0xFFFF
#define LGRAY 0xC618
#define NAVY 0x000F

char seg7[] = {0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07, 0x7f, 0x67, 0x77, 0x7c, 0x39, 0x5e, 0x79, 0x71, 0x40};
int value1 = 0;
int value2 = 0;

int *buffer;
int *backbuffer;
int *status;

// controlling the motion
volatile int * SW_ptr         = (volatile int *)0xFF200040;
volatile int * LEDR_ptr       = (volatile int *)0xFF200000;
volatile int * KEY_ptr       =(volatile int *) 0xFF200050;    // red LED address
int switch_value = 0;
int key_value = 0;
int ball_prev[] = { 0, 0, 10 };
int ball[] = { 0, 0, 10 };
int move[] = { 1, 1 };
int player_width = 10;
int player_height = 30;
int left_player = 120;
int right_player = 120;

void plot_pixel(int x, int y, short int line_colour) {
    *(short int *)(*buffer + (y << 10) + (x << 1)) = line_colour;
}
void draw_square(int x, int y, int size, short color) {
	int i, j;
	for (i = x; i < x+size; i++) {
		for (j = y; j < y+size; j++) {
			plot_pixel(i, j, color);
		}
	}
}

void processInput() {
	int key = *KEY_ptr;
	if (key & 1) {
		// Right Down
		right_player += 1; 
	}
	if (key & 2) {
		// Right Up
		right_player -= 1;
	}
	if (key & 4) {
		// Left Down
		left_player += 1;
	}
	if (key & 8) {
		// Left Up
		left_player -= 1;
	}
}
bool over = false;

void update() {
	ball_prev[0] = ball[0];
	ball_prev[1] = ball[1];
	ball[0] += move[0];
	ball[1] += move[1];
	if (ball[0] < 0) {
		over = true;
		return;
	} else if (ball[0]+ball[2] >= 320) {
		ball[0] = 319-ball[2];
		move[0] = -1;
	}
	if (ball[1] < 0) {
		over = true;
		return;
	} else if (ball[1]+ball[2] >= 240) {
		ball[1] = 239-ball[2];
		move[1] = -1;
	}
	
	if ((ball[0] < player_width && abs(ball[1]-left_player) < 30)) {
		move[0] = 1;
	} else if ((((ball[0]+ball[2]) >= 320-player_width) && (abs(ball[1]-right_player) < 30))) {
		move[0] = -1;
	}
}

void draw_players() {
	for (int i = 0; i < player_width; i++) {
		for (int j = left_player-player_height; j < left_player+player_height; j++) {
			plot_pixel(i, j, WHITE);
		}
	}
	for (int i = 0; i < player_width; i++) {
		for (int j = right_player-player_height; j < right_player+player_height; j++) {
			plot_pixel(320-i, j, WHITE);
		}
	}
}

void render() {
	//draw_square(ball_prev[0], ball_prev[1], ball[2], BLACK);
	draw_square(ball[0], ball[1], ball[2], WHITE);
	draw_players();
}

void clear_screen () {            
    int x,y;
    for ( x = 0; x < 320; x++) {   
        for ( y = 0; y < 240; y++) {
            plot_pixel(x, y, BLACK);
        }
    }
}

void swap() {
	int old_backbuffer = *backbuffer;
	*backbuffer = *buffer;
	*buffer = 1;
	while (*buffer != old_backbuffer) {
	}
}

int main(void) {
	buffer = (int *)0xFF203020;
	backbuffer = (int *)0xFF203024;//location of pixxel buffer controller
	status = (int *)0xFF20302C;//location of pixxel buffer controller
	*backbuffer = 0xc0000000;

	while (!over) {
		processInput();
		update();
		clear_screen();
		render();
		//for (int i = 0; i < 100000; i++) {
		//}
	//	swap();
	}
}
